#include <Wire.h>
#include <Arduino.h>
#include <EEPROM.h>

uint8_t i2c_address = 0x04;

void setup() {
  Wire.begin();
  display("121212");
}

void loop() {
}


void display (String data){

Wire.beginTransmission(i2c_address);        //Start the I2C Session
 
 for (int x=data.length() ; x>=0 ; x--){    //Process the char array one byte at a time
   char aByte=data.charAt(x);
   char value = 0;
   char dp = 0;

   if ((x+1)<data.length()){                //Check if we are setting the decimal place
    if (data.charAt(x+1) == '.'){
      dp = 0x01;
    }
   }
   
   switch (aByte){                          //Send the correct bit sequence for each char
      case '-':                             // '-' sign
        value = 0x04|dp;                    // Add the deciamal place if set
        Wire.write(value);                      //Send the encoded value to the display
        break;

      case '0':                             // '0'
        value = 0xfa|dp;                    // Add the deciamal place if set
        Wire.write(value);                      //Send the encoded value to the display
        break;

      case '1':                             // '1'
        value = 0x60|dp;                    // Add the deciamal place if set
        Wire.write(value);                      //Send the encoded value to the display
        break;

      case '2':                             // '2'
        value = 0xdc|dp;                    // Add the deciamal place if set
        Wire.write(value);                      //Send the encoded value to the display
      break;

      case '3':                             // '3'
        value = 0xf4|dp;                    // Add the deciamal place if set
        Wire.write(value);                      //Send the encoded value to the display
        break;

      case '4':                             // '4'
        value = 0x66|dp;                    // Add the deciamal place if set
        Wire.write(value);                      //Send the encoded value to the display
        break;

      case '5':                             // '5'
        value = 0xb6|dp;                    // Add the deciamal place if set
        Wire.write(value);                      //Send the encoded value to the display
      break;

      case '6':                             // '6'
        value = 0xbe|dp;                    // Add the deciamal place if set
        Wire.write(value);                      //Send the encoded value to the display
        break;

      case '7':                             // '7'
        value = 0xe0|dp;                    // Add the deciamal place if set
        Wire.write(value);                      //Send the encoded value to the display
      break;

      case '8':                             // '8'
        value = 0xff|dp;                    // Add the deciamal place if set
        Wire.write(value);                      //Send the encoded value to the display
        break;

      case '9':                             // '9'
        value = 0xe6|dp;                    // Add the deciamal place if set
        Wire.write(value);                      //Send the encoded value to the display
      break;

      case 'C':                             // 'C'
        value = 0x9a|dp;                    // Add the deciamal place if set
        Wire.write(value);                      //Send the encoded value to the display
        break;

      case 'F':                             // 'F'
        value = 0x8e|dp;                    // Add the deciamal place if set
        Wire.write(value);                      //Send the encoded value to the display
      break;

      case 'o':                             // 'o'
        value = 0x3c|dp;                    // Add the deciamal place if set
        Wire.write(value);                      //Send the encoded value to the display
        break;
    }
  }
  Wire.endTransmission();                   //End the transmission
}
